#include <stdio.h>

#include <unistd.h>
#include <sys/time.h>
#include <sys/types.h>
#include <fcntl.h>
#include <errno.h>

struct pcap_file_header {
	unsigned long magic;
	unsigned short version_major;
	unsigned short version_minor;
	unsigned int thiszone;	/* gmt to local correction */
	unsigned long sigfigs;	/* accuracy of timestamps */
	unsigned long snaplen;	/* max length saved portion of each pkt */
	unsigned long linktype;	/* data link type (DLT_*) */
};

struct pcap_pkthdr {
	struct timeval ts;      /* time stamp */
	unsigned long caplen;     /* length of portion present */
	unsigned long len;        /* length this packet (off wire) */
};

typedef struct {
	unsigned short len;
	unsigned short command;
} _N_DATA;
                
                

int main(int argc, char **argv)
{
int f;
int rc;
char filename[] = "./dat";
struct pcap_file_header pcap_header;
struct pcap_pkthdr pcap_pkt;
unsigned char buffer[2048];

_N_DATA n_data;
char *p;

	f = open(filename, O_RDONLY);
	if (f == -1)
	{
		fprintf(stdout, "unable to open %s %s", filename, strerror(errno));
		return 0;
	}
	read(f, &pcap_header, sizeof(pcap_header));

	while (((rc = read(f, &pcap_pkt, sizeof(pcap_pkt))) == sizeof(pcap_pkt)))
	{
		int ln = 54;
		char *x;
		memset(buffer, 0, sizeof(buffer));
		read(f, buffer, pcap_pkt.len);
		if (pcap_pkt.len < 56)
			continue;
		x = buffer + 54;
		while (ln < pcap_pkt.len)
		{
		        n_data.len = *x + ((*(x + 1) << 8) & 0xff00);
        	        n_data.command = *(x+2) + ((*(x+3) << 8) & 0xff00);
			if (n_data.command > 0 && n_data.command < 1000 && n_data.len < 2048 && n_data.len > 0)
			{
				p = x+4;
				fprintf(stdout, "plen = %u  [len %u cmd %u] %s\n", pcap_pkt.len, n_data.len, n_data.command, n_data.len ? p : "");
			}
			else
				fprintf(stdout, "%s\n", x);
			ln += n_data.len;
			x += n_data.len;
		}
	}
	close(f);
}
                        